var jvm = {
    inherits: function(child, parent) {
        function temp() {}
        temp.prototype = parent.prototype, child.prototype = new temp, child.prototype.constructor = child, child.parentClass = parent
    },
    mixin: function(target, source) {
        var prop;
        for (prop in source.prototype) source.prototype.hasOwnProperty(prop) && (target.prototype[prop] = source.prototype[prop])
    },
    min: function(values) {
        var i, min = Number.MAX_VALUE;
        if (values instanceof Array)
            for (i = 0; i < values.length; i++) values[i] < min && (min = values[i]);
        else
            for (i in values) values[i] < min && (min = values[i]);
        return min
    },
    max: function(values) {
        var i, max = Number.MIN_VALUE;
        if (values instanceof Array)
            for (i = 0; i < values.length; i++) values[i] > max && (max = values[i]);
        else
            for (i in values) values[i] > max && (max = values[i]);
        return max
    },
    keys: function(object) {
        var key, keys = [];
        for (key in object) keys.push(key);
        return keys
    },
    values: function(object) {
        var key, i, values = [];
        for (i = 0; i < arguments.length; i++) {
            object = arguments[i];
            for (key in object) values.push(object[key])
        }
        return values
    },
    whenImageLoaded: function(url) {
        var deferred = new jvm.$.Deferred,
            img = jvm.$("<img/>");
        return img.error(function() {
            deferred.reject()
        }).load(function() {
            deferred.resolve(img)
        }), img.attr("src", url), deferred
    },
    isImageUrl: function(s) {
        return /\.\w{3,4}$/.test(s)
    }
};
Array.prototype.indexOf || (Array.prototype.indexOf = function(searchElement, fromIndex) {
        var k;
        if (null == this) throw new TypeError('"this" is null or not defined');
        var O = Object(this),
            len = O.length >>> 0;
        if (0 === len) return -1;
        var n = +fromIndex || 0;
        if (Math.abs(n) === 1 / 0 && (n = 0), n >= len) return -1;
        for (k = Math.max(n >= 0 ? n : len - Math.abs(n), 0); k < len;) {
            if (k in O && O[k] === searchElement) return k;
            k++
        }
        return -1
    }),
    function(factory) {
        "object" == typeof exports ? module.exports = factory : "function" == typeof define && define.amd ? define(["jquery"], factory) : factory(jQuery)
    }(function($) {
        jvm.$ = $;
        var apiParams = {
            set: {
                colors: 1,
                values: 1,
                backgroundColor: 1,
                scaleColors: 1,
                normalizeFunction: 1,
                focus: 1
            },
            get: {
                selectedRegions: 1,
                selectedMarkers: 1,
                mapObject: 1,
                regionName: 1
            }
        };
        $.fn.vectorMap = function(options) {
            var map, methodName, map = this.children(".jvectormap-container").data("mapObject");
            if ("addMap" === options) jvm.Map.maps[arguments[1]] = arguments[2];
            else {
                if (("set" === options || "get" === options) && apiParams[options][arguments[1]]) return methodName = arguments[1].charAt(0).toUpperCase() + arguments[1].substr(1), map[options + methodName].apply(map, Array.prototype.slice.call(arguments, 2));
                options = options || {}, options.container = this, map = new jvm.Map(options)
            }
            return this
        }
    }),
    function(factory) {
        "function" == typeof define && define.amd ? define(["jquery"], factory) : "object" == typeof exports ? module.exports = factory : factory(jQuery)
    }(function($) {
        function handler(event) {
            var orgEvent = event || window.event,
                args = slice.call(arguments, 1),
                delta = 0,
                deltaX = 0,
                deltaY = 0,
                absDelta = 0;
            if (event = $.event.fix(orgEvent), event.type = "mousewheel", "detail" in orgEvent && (deltaY = -1 * orgEvent.detail), "wheelDelta" in orgEvent && (deltaY = orgEvent.wheelDelta), "wheelDeltaY" in orgEvent && (deltaY = orgEvent.wheelDeltaY), "wheelDeltaX" in orgEvent && (deltaX = -1 * orgEvent.wheelDeltaX), "axis" in orgEvent && orgEvent.axis === orgEvent.HORIZONTAL_AXIS && (deltaX = -1 * deltaY, deltaY = 0), delta = 0 === deltaY ? deltaX : deltaY, "deltaY" in orgEvent && (deltaY = -1 * orgEvent.deltaY, delta = deltaY), "deltaX" in orgEvent && (deltaX = orgEvent.deltaX, 0 === deltaY && (delta = -1 * deltaX)), 0 !== deltaY || 0 !== deltaX) {
                if (1 === orgEvent.deltaMode) {
                    var lineHeight = $.data(this, "mousewheel-line-height");
                    delta *= lineHeight, deltaY *= lineHeight, deltaX *= lineHeight
                } else if (2 === orgEvent.deltaMode) {
                    var pageHeight = $.data(this, "mousewheel-page-height");
                    delta *= pageHeight, deltaY *= pageHeight, deltaX *= pageHeight
                }
                return absDelta = Math.max(Math.abs(deltaY), Math.abs(deltaX)), (!lowestDelta || absDelta < lowestDelta) && (lowestDelta = absDelta, shouldAdjustOldDeltas(orgEvent, absDelta) && (lowestDelta /= 40)), shouldAdjustOldDeltas(orgEvent, absDelta) && (delta /= 40, deltaX /= 40, deltaY /= 40), delta = Math[delta >= 1 ? "floor" : "ceil"](delta / lowestDelta), deltaX = Math[deltaX >= 1 ? "floor" : "ceil"](deltaX / lowestDelta), deltaY = Math[deltaY >= 1 ? "floor" : "ceil"](deltaY / lowestDelta), event.deltaX = deltaX, event.deltaY = deltaY, event.deltaFactor = lowestDelta, event.deltaMode = 0, args.unshift(event, delta, deltaX, deltaY), nullLowestDeltaTimeout && clearTimeout(nullLowestDeltaTimeout), nullLowestDeltaTimeout = setTimeout(nullLowestDelta, 200), ($.event.dispatch || $.event.handle).apply(this, args)
            }
        }

        function nullLowestDelta() {
            lowestDelta = null
        }

        function shouldAdjustOldDeltas(orgEvent, absDelta) {
            return special.settings.adjustOldDeltas && "mousewheel" === orgEvent.type && absDelta % 120 == 0
        }
        var nullLowestDeltaTimeout, lowestDelta, toFix = ["wheel", "mousewheel", "DOMMouseScroll", "MozMousePixelScroll"],
            toBind = "onwheel" in document || document.documentMode >= 9 ? ["wheel"] : ["mousewheel", "DomMouseScroll", "MozMousePixelScroll"],
            slice = Array.prototype.slice;
        if ($.event.fixHooks)
            for (var i = toFix.length; i;) $.event.fixHooks[toFix[--i]] = $.event.mouseHooks;
        var special = $.event.special.mousewheel = {
            version: "3.1.9",
            setup: function() {
                if (this.addEventListener)
                    for (var i = toBind.length; i;) this.addEventListener(toBind[--i], handler, !1);
                else this.onmousewheel = handler;
                $.data(this, "mousewheel-line-height", special.getLineHeight(this)), $.data(this, "mousewheel-page-height", special.getPageHeight(this))
            },
            teardown: function() {
                if (this.removeEventListener)
                    for (var i = toBind.length; i;) this.removeEventListener(toBind[--i], handler, !1);
                else this.onmousewheel = null
            },
            getLineHeight: function(elem) {
                return parseInt($(elem)["offsetParent" in $.fn ? "offsetParent" : "parent"]().css("fontSize"), 10)
            },
            getPageHeight: function(elem) {
                return $(elem).height()
            },
            settings: {
                adjustOldDeltas: !0
            }
        };
        $.fn.extend({
            mousewheel: function(fn) {
                return fn ? this.bind("mousewheel", fn) : this.trigger("mousewheel")
            },
            unmousewheel: function(fn) {
                return this.unbind("mousewheel", fn)
            }
        })
    }), jvm.AbstractElement = function(name, config) {
        this.node = this.createElement(name), this.name = name, this.properties = {}, config && this.set(config)
    }, jvm.AbstractElement.prototype.set = function(property, value) {
        var key;
        if ("object" == typeof property)
            for (key in property) this.properties[key] = property[key], this.applyAttr(key, property[key]);
        else this.properties[property] = value, this.applyAttr(property, value)
    }, jvm.AbstractElement.prototype.get = function(property) {
        return this.properties[property]
    }, jvm.AbstractElement.prototype.applyAttr = function(property, value) {
        this.node.setAttribute(property, value)
    }, jvm.AbstractElement.prototype.remove = function() {
        jvm.$(this.node).remove()
    }, jvm.AbstractCanvasElement = function(container, width, height) {
        this.container = container, this.setSize(width, height), this.rootElement = new jvm[this.classPrefix + "GroupElement"], this.node.appendChild(this.rootElement.node), this.container.appendChild(this.node)
    }, jvm.AbstractCanvasElement.prototype.add = function(element, group) {
        group = group || this.rootElement, group.add(element), element.canvas = this
    }, jvm.AbstractCanvasElement.prototype.addPath = function(config, style, group) {
        var el = new jvm[this.classPrefix + "PathElement"](config, style);
        return this.add(el, group), el
    }, jvm.AbstractCanvasElement.prototype.addCircle = function(config, style, group) {
        var el = new jvm[this.classPrefix + "CircleElement"](config, style);
        return this.add(el, group), el
    }, jvm.AbstractCanvasElement.prototype.addImage = function(config, style, group) {
        var el = new jvm[this.classPrefix + "ImageElement"](config, style);
        return this.add(el, group), el
    }, jvm.AbstractCanvasElement.prototype.addText = function(config, style, group) {
        var el = new jvm[this.classPrefix + "TextElement"](config, style);
        return this.add(el, group), el
    }, jvm.AbstractCanvasElement.prototype.addGroup = function(parentGroup) {
        var el = new jvm[this.classPrefix + "GroupElement"];
        return parentGroup ? parentGroup.node.appendChild(el.node) : this.node.appendChild(el.node), el.canvas = this, el
    }, jvm.AbstractShapeElement = function(name, config, style) {
        this.style = style || {}, this.style.current = this.style.current || {}, this.isHovered = !1, this.isSelected = !1, this.updateStyle()
    }, jvm.AbstractShapeElement.prototype.setStyle = function(property, value) {
        var styles = {};
        "object" == typeof property ? styles = property : styles[property] = value, jvm.$.extend(this.style.current, styles), this.updateStyle()
    }, jvm.AbstractShapeElement.prototype.updateStyle = function() {
        var attrs = {};
        jvm.AbstractShapeElement.mergeStyles(attrs, this.style.initial), jvm.AbstractShapeElement.mergeStyles(attrs, this.style.current), this.isHovered && jvm.AbstractShapeElement.mergeStyles(attrs, this.style.hover), this.isSelected && (jvm.AbstractShapeElement.mergeStyles(attrs, this.style.selected), this.isHovered && jvm.AbstractShapeElement.mergeStyles(attrs, this.style.selectedHover)), this.set(attrs)
    }, jvm.AbstractShapeElement.mergeStyles = function(styles, newStyles) {
        var key;
        newStyles = newStyles || {};
        for (key in newStyles) null === newStyles[key] ? delete styles[key] : styles[key] = newStyles[key]
    }, jvm.SVGElement = function(name, config) {
        jvm.SVGElement.parentClass.apply(this, arguments)
    }, jvm.inherits(jvm.SVGElement, jvm.AbstractElement), jvm.SVGElement.svgns = "http://www.w3.org/2000/svg", jvm.SVGElement.prototype.createElement = function(tagName) {
        return document.createElementNS(jvm.SVGElement.svgns, tagName)
    }, jvm.SVGElement.prototype.addClass = function(className) {
        this.node.setAttribute("class", className)
    }, jvm.SVGElement.prototype.getElementCtr = function(ctr) {
        return jvm["SVG" + ctr]
    }, jvm.SVGElement.prototype.getBBox = function() {
        return this.node.getBBox()
    }, jvm.SVGGroupElement = function() {
        jvm.SVGGroupElement.parentClass.call(this, "g")
    }, jvm.inherits(jvm.SVGGroupElement, jvm.SVGElement), jvm.SVGGroupElement.prototype.add = function(element) {
        this.node.appendChild(element.node)
    }, jvm.SVGCanvasElement = function(container, width, height) {
        this.classPrefix = "SVG", jvm.SVGCanvasElement.parentClass.call(this, "svg"), this.defsElement = new jvm.SVGElement("defs"), this.node.appendChild(this.defsElement.node), jvm.AbstractCanvasElement.apply(this, arguments)
    }, jvm.inherits(jvm.SVGCanvasElement, jvm.SVGElement), jvm.mixin(jvm.SVGCanvasElement, jvm.AbstractCanvasElement), jvm.SVGCanvasElement.prototype.setSize = function(width, height) {
        this.width = width, this.height = height, this.node.setAttribute("width", width), this.node.setAttribute("height", height)
    }, jvm.SVGCanvasElement.prototype.applyTransformParams = function(scale, transX, transY) {
        this.scale = scale, this.transX = transX, this.transY = transY, this.rootElement.node.setAttribute("transform", "scale(" + scale + ") translate(" + transX + ", " + transY + ")")
    }, jvm.SVGShapeElement = function(name, config, style) {
        jvm.SVGShapeElement.parentClass.call(this, name, config), jvm.AbstractShapeElement.apply(this, arguments)
    }, jvm.inherits(jvm.SVGShapeElement, jvm.SVGElement), jvm.mixin(jvm.SVGShapeElement, jvm.AbstractShapeElement), jvm.SVGShapeElement.prototype.applyAttr = function(attr, value) {
        var patternEl, imageEl, that = this;
        "fill" === attr && jvm.isImageUrl(value) ? jvm.SVGShapeElement.images[value] ? this.applyAttr("fill", "url(#image" + jvm.SVGShapeElement.images[value] + ")") : jvm.whenImageLoaded(value).then(function(img) {
            imageEl = new jvm.SVGElement("image"), imageEl.node.setAttributeNS("http://www.w3.org/1999/xlink", "href", value), imageEl.applyAttr("x", "0"), imageEl.applyAttr("y", "0"), imageEl.applyAttr("width", img[0].width), imageEl.applyAttr("height", img[0].height), patternEl = new jvm.SVGElement("pattern"), patternEl.applyAttr("id", "image" + jvm.SVGShapeElement.imageCounter), patternEl.applyAttr("x", 0), patternEl.applyAttr("y", 0), patternEl.applyAttr("width", img[0].width / 2), patternEl.applyAttr("height", img[0].height / 2), patternEl.applyAttr("viewBox", "0 0 " + img[0].width + " " + img[0].height), patternEl.applyAttr("patternUnits", "userSpaceOnUse"), patternEl.node.appendChild(imageEl.node), that.canvas.defsElement.node.appendChild(patternEl.node), jvm.SVGShapeElement.images[value] = jvm.SVGShapeElement.imageCounter++, that.applyAttr("fill", "url(#image" + jvm.SVGShapeElement.images[value] + ")")
        }) : jvm.SVGShapeElement.parentClass.prototype.applyAttr.apply(this, arguments)
    }, jvm.SVGShapeElement.imageCounter = 1, jvm.SVGShapeElement.images = {}, jvm.SVGPathElement = function(config, style) {
        jvm.SVGPathElement.parentClass.call(this, "path", config, style), this.node.setAttribute("fill-rule", "evenodd")
    }, jvm.inherits(jvm.SVGPathElement, jvm.SVGShapeElement), jvm.SVGCircleElement = function(config, style) {
        jvm.SVGCircleElement.parentClass.call(this, "circle", config, style)
    }, jvm.inherits(jvm.SVGCircleElement, jvm.SVGShapeElement), jvm.SVGImageElement = function(config, style) {
        jvm.SVGImageElement.parentClass.call(this, "image", config, style)
    }, jvm.inherits(jvm.SVGImageElement, jvm.SVGShapeElement), jvm.SVGImageElement.prototype.applyAttr = function(attr, value) {
        var imageUrl, that = this;
        "image" == attr ? ("object" == typeof value ? (imageUrl = value.url, this.offset = value.offset) : (imageUrl = value, this.offset = [0, 0]), jvm.whenImageLoaded(imageUrl).then(function(img) {
            that.node.setAttributeNS("http://www.w3.org/1999/xlink", "href", imageUrl), that.width = img[0].width, that.height = img[0].height, that.applyAttr("width", that.width), that.applyAttr("height", that.height), that.applyAttr("x", that.cx - that.width / 2 + that.offset[0]), that.applyAttr("y", that.cy - that.height / 2 + that.offset[1]), jvm.$(that.node).trigger("imageloaded", [img])
        })) : "cx" == attr ? (this.cx = value, this.width && this.applyAttr("x", value - this.width / 2 + this.offset[0])) : "cy" == attr ? (this.cy = value, this.height && this.applyAttr("y", value - this.height / 2 + this.offset[1])) : jvm.SVGImageElement.parentClass.prototype.applyAttr.apply(this, arguments)
    }, jvm.SVGTextElement = function(config, style) {
        jvm.SVGTextElement.parentClass.call(this, "text", config, style)
    }, jvm.inherits(jvm.SVGTextElement, jvm.SVGShapeElement), jvm.SVGTextElement.prototype.applyAttr = function(attr, value) {
        "text" === attr ? this.node.textContent = value : jvm.SVGTextElement.parentClass.prototype.applyAttr.apply(this, arguments)
    }, jvm.VMLElement = function(name, config) {
        jvm.VMLElement.VMLInitialized || jvm.VMLElement.initializeVML(), jvm.VMLElement.parentClass.apply(this, arguments)
    }, jvm.inherits(jvm.VMLElement, jvm.AbstractElement), jvm.VMLElement.VMLInitialized = !1, jvm.VMLElement.initializeVML = function() {
        try {
            document.namespaces.rvml || document.namespaces.add("rvml", "urn:schemas-microsoft-com:vml"), jvm.VMLElement.prototype.createElement = function(tagName) {
                return document.createElement("<rvml:" + tagName + ' class="rvml">')
            }
        } catch (e) {
            jvm.VMLElement.prototype.createElement = function(tagName) {
                return document.createElement("<" + tagName + ' xmlns="urn:schemas-microsoft.com:vml" class="rvml">')
            }
        }
        document.createStyleSheet().addRule(".rvml", "behavior:url(#default#VML)"), jvm.VMLElement.VMLInitialized = !0
    }, jvm.VMLElement.prototype.getElementCtr = function(ctr) {
        return jvm["VML" + ctr]
    }, jvm.VMLElement.prototype.addClass = function(className) {
        jvm.$(this.node).addClass(className)
    }, jvm.VMLElement.prototype.applyAttr = function(attr, value) {
        this.node[attr] = value
    }, jvm.VMLElement.prototype.getBBox = function() {
        var node = jvm.$(this.node);
        return {
            x: node.position().left / this.canvas.scale,
            y: node.position().top / this.canvas.scale,
            width: node.width() / this.canvas.scale,
            height: node.height() / this.canvas.scale
        }
    }, jvm.VMLGroupElement = function() {
        jvm.VMLGroupElement.parentClass.call(this, "group"), this.node.style.left = "0px", this.node.style.top = "0px", this.node.coordorigin = "0 0"
    }, jvm.inherits(jvm.VMLGroupElement, jvm.VMLElement), jvm.VMLGroupElement.prototype.add = function(element) {
        this.node.appendChild(element.node)
    }, jvm.VMLCanvasElement = function(container, width, height) {
        this.classPrefix = "VML", jvm.VMLCanvasElement.parentClass.call(this, "group"), jvm.AbstractCanvasElement.apply(this, arguments), this.node.style.position = "absolute"
    }, jvm.inherits(jvm.VMLCanvasElement, jvm.VMLElement), jvm.mixin(jvm.VMLCanvasElement, jvm.AbstractCanvasElement), jvm.VMLCanvasElement.prototype.setSize = function(width, height) {
        var paths, groups, i, l;
        if (this.width = width, this.height = height, this.node.style.width = width + "px", this.node.style.height = height + "px", this.node.coordsize = width + " " + height, this.node.coordorigin = "0 0", this.rootElement) {
            for (paths = this.rootElement.node.getElementsByTagName("shape"), i = 0, l = paths.length; i < l; i++) paths[i].coordsize = width + " " + height, paths[i].style.width = width + "px", paths[i].style.height = height + "px";
            for (groups = this.node.getElementsByTagName("group"), i = 0, l = groups.length; i < l; i++) groups[i].coordsize = width + " " + height, groups[i].style.width = width + "px", groups[i].style.height = height + "px"
        }
    }, jvm.VMLCanvasElement.prototype.applyTransformParams = function(scale, transX, transY) {
        this.scale = scale, this.transX = transX, this.transY = transY, this.rootElement.node.coordorigin = this.width - transX - this.width / 100 + "," + (this.height - transY - this.height / 100), this.rootElement.node.coordsize = this.width / scale + "," + this.height / scale
    }, jvm.VMLShapeElement = function(name, config) {
        jvm.VMLShapeElement.parentClass.call(this, name, config), this.fillElement = new jvm.VMLElement("fill"), this.strokeElement = new jvm.VMLElement("stroke"), this.node.appendChild(this.fillElement.node), this.node.appendChild(this.strokeElement.node), this.node.stroked = !1, jvm.AbstractShapeElement.apply(this, arguments)
    }, jvm.inherits(jvm.VMLShapeElement, jvm.VMLElement), jvm.mixin(jvm.VMLShapeElement, jvm.AbstractShapeElement), jvm.VMLShapeElement.prototype.applyAttr = function(attr, value) {
        switch (attr) {
            case "fill":
                this.node.fillcolor = value;
                break;
            case "fill-opacity":
                this.fillElement.node.opacity = Math.round(100 * value) + "%";
                break;
            case "stroke":
                this.node.stroked = "none" !== value, this.node.strokecolor = value;
                break;
            case "stroke-opacity":
                this.strokeElement.node.opacity = Math.round(100 * value) + "%";
                break;
            case "stroke-width":
                0 === parseInt(value, 10) ? this.node.stroked = !1 : this.node.stroked = !0, this.node.strokeweight = value;
                break;
            case "d":
                this.node.path = jvm.VMLPathElement.pathSvgToVml(value);
                break;
            default:
                jvm.VMLShapeElement.parentClass.prototype.applyAttr.apply(this, arguments)
        }
    }, jvm.VMLPathElement = function(config, style) {
        var scale = new jvm.VMLElement("skew");
        jvm.VMLPathElement.parentClass.call(this, "shape", config, style), this.node.coordorigin = "0 0", scale.node.on = !0, scale.node.matrix = "0.01,0,0,0.01,0,0", scale.node.offset = "0,0", this.node.appendChild(scale.node)
    }, jvm.inherits(jvm.VMLPathElement, jvm.VMLShapeElement), jvm.VMLPathElement.prototype.applyAttr = function(attr, value) {
        "d" === attr ? this.node.path = jvm.VMLPathElement.pathSvgToVml(value) : jvm.VMLShapeElement.prototype.applyAttr.call(this, attr, value)
    }, jvm.VMLPathElement.pathSvgToVml = function(path) {
        var ctrlx, ctrly, cx = 0,
            cy = 0;
        return path = path.replace(/(-?\d+)e(-?\d+)/g, "0"), path.replace(/([MmLlHhVvCcSs])\s*((?:-?\d*(?:\.\d+)?\s*,?\s*)+)/g, function(segment, letter, coords, index) {
            coords = coords.replace(/(\d)-/g, "$1,-").replace(/^\s+/g, "").replace(/\s+$/g, "").replace(/\s+/g, ",").split(","), coords[0] || coords.shift();
            for (var i = 0, l = coords.length; i < l; i++) coords[i] = Math.round(100 * coords[i]);
            switch (letter) {
                case "m":
                    return cx += coords[0], cy += coords[1], "t" + coords.join(",");
                case "M":
                    return cx = coords[0], cy = coords[1], "m" + coords.join(",");
                case "l":
                    return cx += coords[0], cy += coords[1], "r" + coords.join(",");
                case "L":
                    return cx = coords[0], cy = coords[1], "l" + coords.join(",");
                case "h":
                    return cx += coords[0], "r" + coords[0] + ",0";
                case "H":
                    return "l" + (cx = coords[0]) + "," + cy;
                case "v":
                    return cy += coords[0], "r0," + coords[0];
                case "V":
                    return cy = coords[0], "l" + cx + "," + cy;
                case "c":
                    return ctrlx = cx + coords[coords.length - 4], ctrly = cy + coords[coords.length - 3], cx += coords[coords.length - 2], cy += coords[coords.length - 1], "v" + coords.join(",");
                case "C":
                    return ctrlx = coords[coords.length - 4], ctrly = coords[coords.length - 3], cx = coords[coords.length - 2], cy = coords[coords.length - 1], "c" + coords.join(",");
                case "s":
                    return coords.unshift(cy - ctrly), coords.unshift(cx - ctrlx), ctrlx = cx + coords[coords.length - 4], ctrly = cy + coords[coords.length - 3], cx += coords[coords.length - 2], cy += coords[coords.length - 1], "v" + coords.join(",");
                case "S":
                    return coords.unshift(cy + cy - ctrly), coords.unshift(cx + cx - ctrlx), ctrlx = coords[coords.length - 4], ctrly = coords[coords.length - 3], cx = coords[coords.length - 2], cy = coords[coords.length - 1], "c" + coords.join(",")
            }
            return ""
        }).replace(/z/g, "e")
    }, jvm.VMLCircleElement = function(config, style) {
        jvm.VMLCircleElement.parentClass.call(this, "oval", config, style)
    }, jvm.inherits(jvm.VMLCircleElement, jvm.VMLShapeElement), jvm.VMLCircleElement.prototype.applyAttr = function(attr, value) {
        switch (attr) {
            case "r":
                this.node.style.width = 2 * value + "px", this.node.style.height = 2 * value + "px", this.applyAttr("cx", this.get("cx") || 0), this.applyAttr("cy", this.get("cy") || 0);
                break;
            case "cx":
                if (!value) return;
                this.node.style.left = value - (this.get("r") || 0) + "px";
                break;
            case "cy":
                if (!value) return;
                this.node.style.top = value - (this.get("r") || 0) + "px";
                break;
            default:
                jvm.VMLCircleElement.parentClass.prototype.applyAttr.call(this, attr, value)
        }
    }, jvm.VectorCanvas = function(container, width, height) {
        return this.mode = window.SVGAngle ? "svg" : "vml", "svg" == this.mode ? this.impl = new jvm.SVGCanvasElement(container, width, height) : this.impl = new jvm.VMLCanvasElement(container, width, height), this.impl.mode = this.mode, this.impl
    }, jvm.SimpleScale = function(scale) {
        this.scale = scale
    }, jvm.SimpleScale.prototype.getValue = function(value) {
        return value
    }, jvm.OrdinalScale = function(scale) {
        this.scale = scale
    }, jvm.OrdinalScale.prototype.getValue = function(value) {
        return this.scale[value]
    }, jvm.OrdinalScale.prototype.getTicks = function() {
        var key, ticks = [];
        for (key in this.scale) ticks.push({
            label: key,
            value: this.scale[key]
        });
        return ticks
    }, jvm.NumericScale = function(scale, normalizeFunction, minValue, maxValue) {
        this.scale = [], normalizeFunction = normalizeFunction || "linear", scale && this.setScale(scale), normalizeFunction && this.setNormalizeFunction(normalizeFunction), void 0 !== minValue && this.setMin(minValue), void 0 !== maxValue && this.setMax(maxValue)
    }, jvm.NumericScale.prototype = {
        setMin: function(min) {
            this.clearMinValue = min, "function" == typeof this.normalize ? this.minValue = this.normalize(min) : this.minValue = min
        },
        setMax: function(max) {
            this.clearMaxValue = max, "function" == typeof this.normalize ? this.maxValue = this.normalize(max) : this.maxValue = max
        },
        setScale: function(scale) {
            var i;
            for (this.scale = [], i = 0; i < scale.length; i++) this.scale[i] = [scale[i]]
        },
        setNormalizeFunction: function(f) {
            "polynomial" === f ? this.normalize = function(value) {
                return Math.pow(value, .2)
            } : "linear" === f ? delete this.normalize : this.normalize = f, this.setMin(this.clearMinValue), this.setMax(this.clearMaxValue)
        },
        getValue: function(value) {
            var l, c, lengthes = [],
                fullLength = 0,
                i = 0;
            for ("function" == typeof this.normalize && (value = this.normalize(value)), i = 0; i < this.scale.length - 1; i++) l = this.vectorLength(this.vectorSubtract(this.scale[i + 1], this.scale[i])), lengthes.push(l), fullLength += l;
            for (c = (this.maxValue - this.minValue) / fullLength, i = 0; i < lengthes.length; i++) lengthes[i] *= c;
            for (i = 0, value -= this.minValue; value - lengthes[i] >= 0;) value -= lengthes[i], i++;
            return value = i == this.scale.length - 1 ? this.vectorToNum(this.scale[i]) : this.vectorToNum(this.vectorAdd(this.scale[i], this.vectorMult(this.vectorSubtract(this.scale[i + 1], this.scale[i]), value / lengthes[i])))
        },
        vectorToNum: function(vector) {
            var i, num = 0;
            for (i = 0; i < vector.length; i++) num += Math.round(vector[i]) * Math.pow(256, vector.length - i - 1);
            return num
        },
        vectorSubtract: function(vector1, vector2) {
            var i, vector = [];
            for (i = 0; i < vector1.length; i++) vector[i] = vector1[i] - vector2[i];
            return vector
        },
        vectorAdd: function(vector1, vector2) {
            var i, vector = [];
            for (i = 0; i < vector1.length; i++) vector[i] = vector1[i] + vector2[i];
            return vector
        },
        vectorMult: function(vector, num) {
            var i, result = [];
            for (i = 0; i < vector.length; i++) result[i] = vector[i] * num;
            return result
        },
        vectorLength: function(vector) {
            var i, result = 0;
            for (i = 0; i < vector.length; i++) result += vector[i] * vector[i];
            return Math.sqrt(result)
        },
        getTicks: function() {
            var tick, v, extent = [this.clearMinValue, this.clearMaxValue],
                span = extent[1] - extent[0],
                step = Math.pow(10, Math.floor(Math.log(span / 5) / Math.LN10)),
                err = 5 / span * step,
                ticks = [];
            for (err <= .15 ? step *= 10 : err <= .35 ? step *= 5 : err <= .75 && (step *= 2), extent[0] = Math.floor(extent[0] / step) * step, extent[1] = Math.ceil(extent[1] / step) * step, tick = extent[0]; tick <= extent[1];) v = tick == extent[0] ? this.clearMinValue : tick == extent[1] ? this.clearMaxValue : tick, ticks.push({
                label: tick,
                value: this.getValue(v)
            }), tick += step;
            return ticks
        }
    }, jvm.ColorScale = function(colors, normalizeFunction, minValue, maxValue) {
        jvm.ColorScale.parentClass.apply(this, arguments)
    }, jvm.inherits(jvm.ColorScale, jvm.NumericScale), jvm.ColorScale.prototype.setScale = function(scale) {
        var i;
        for (i = 0; i < scale.length; i++) this.scale[i] = jvm.ColorScale.rgbToArray(scale[i])
    }, jvm.ColorScale.prototype.getValue = function(value) {
        return jvm.ColorScale.numToRgb(jvm.ColorScale.parentClass.prototype.getValue.call(this, value))
    }, jvm.ColorScale.arrayToRgb = function(ar) {
        var d, i, rgb = "#";
        for (i = 0; i < ar.length; i++) d = ar[i].toString(16), rgb += 1 == d.length ? "0" + d : d;
        return rgb
    }, jvm.ColorScale.numToRgb = function(num) {
        for (num = num.toString(16); num.length < 6;) num = "0" + num;
        return "#" + num
    }, jvm.ColorScale.rgbToArray = function(rgb) {
        return rgb = rgb.substr(1), [parseInt(rgb.substr(0, 2), 16), parseInt(rgb.substr(2, 2), 16), parseInt(rgb.substr(4, 2), 16)]
    }, jvm.Legend = function(params) {
        this.params = params || {}, this.map = this.params.map, this.series = this.params.series, this.body = jvm.$("<div/>"), this.body.addClass("jvectormap-legend"), this.params.cssClass && this.body.addClass(this.params.cssClass), params.vertical ? this.map.legendCntVertical.append(this.body) : this.map.legendCntHorizontal.append(this.body), this.render()
    }, jvm.Legend.prototype.render = function() {
        var i, tick, sample, label, ticks = this.series.scale.getTicks(),
            inner = jvm.$("<div/>").addClass("jvectormap-legend-inner");
        for (this.body.html(""), this.params.title && this.body.append(jvm.$("<div/>").addClass("jvectormap-legend-title").html(this.params.title))